#Script Python to filter kinases name and alias Papers from Pubmed
#
# 6_filter_kinase.py:
#

# Library
from itertools import *
import re

# Function to search kinases
def exact_Match(phrase, word):
    b = r'(\s|^|$)'
    res = re.search(b + word + b, phrase)
    return bool(res)

# Main
def main():
	# File Input
	fin="5_entry_complete_kws_clean.txt"
	# File Output
	ffusion="6_entry_complete_kws_clean_kinase.txt"
	# Read 12 lines
	nlines=12
	# kinases
	search_kinase=["kinase","Kinase","ADRBK1","GRK2","BARK1","ADRBK2","GRK3","BARK2","AKT1","RAC","PKB","PRKBA","AKT","AKT2","AKT3","PKBG","RAC-gamma","PRKBG","CDC42BPA","MRCKA","PK428","FLJ23347","KIAA0451","MRCK","CDC42BPB","MRCKB","KIAA1124","CDC42BPG","HSMDPKIN","MRCKgamma","DMPK2","kappa-200","CIT","KIAA0949","STK21","CRIK","DMPK","DM","DM1","DMK","DM1PK","MDPK","MT-PK","GRK1","RHOK","GPRK1","RK","GRK4","GPRK2L","GPRK4","GRK5","GPRK5","GRK6","GPRK6","GRK7","GPRK7","LATS1","WARTS","LATS2","MAST1","SAST","KIAA0973","MAST2","MAST205","KIAA0807","MAST3","KIAA0561","MAST4","KIAA0303","MASTL","FLJ14813","THC2","PDPK1","PDK1","PKN1","PRKCL1","DBK","PRK1","PKN","MGC46204","PAK1","PKN2","PRKCL2","PRK2","Pak-2","PKN3","PKNbeta","PRKACA","PKACa","PRKACB","PKACb","PRKACG","PKACg","PRKCA","PKCA","PRKCB","PRKCB2","PKCB","PRKCB1","PRKCD","PRKCE","PRKCG","PKCG","SCA14","PKCC","MGC57564","PRKCH","PRKCL","PKC-L","PKCL","PRKCI","DXS1179E","PKCI","PRKCQ","PRKCZ","PKC2","PRKG1","PRKGR1B","PRKG1B","PGK","PKG","PRKG2","cGKII","PRKGR2","PRKX","PKX1","PRKY","PRKYP","PRKXP3","ROCK1","p160ROCK","ROCK2","RPS6KA1","RSK","RSK1","HU-1","RPS6KA2","RSK","RSK3","HU-2","RPS6KA3","MRX19","CLS","RSK","RSK2","HU-3","RPS6KA4","RSK-B","MSK2","RPS6KA5","MSK1","RLPK","RPS6KA6","RSK4","RPS6KB1","STK14A","S6K1","p70(S6K)-alpha","PS6K","RPS6KB2","p70S6Kb","P70-BETA","STK14B","KLS","RPS6KC1","humS6PKh1","RPS6KL1","MGC11287","SGK1","SGK","SGK2","SGK3","SGK2","SGKL","STK32A","MGC22688","YANK1","STK32B","STKG6","YANK2","STK32","HSA250839","STK32C","PKE","MGC23665","YANK3","STK38","NDR","STK38L","KIAA0965","NDR2","ADCK1","FLJ39600","ADCK2","MGC20727","ADCK3","CABC1","COQ8","SCAR9","ADCK5","FLJ35454","ALPK1","Lak","FLJ22670","KIAA1527","ALPK2","HAK","ALPK3","MAK","KIAA1330","Midori","ATM","ATA","ATDC","ATC","ATD","TEL1","TELO1","ATR","FRP1","SCKL","SCKL1","MEC1","BCKDK","BCR","D22S11","BCR1","D22S662","CML","PHL","ALL","BRD4","HUNKI","MCAP","CAP","HUNK1","EEF2K","eEF-2K","FASTK","FAST","MTOR","FRAP","FRAP2","FRAP1","RAFT1","RAPT1","FLJ44809","PDK1","PDK2","PDHK2","PDK3","PDK4","PRKDC","HYRC","HYRC1","DNPK1","p350","DNAPK","XRCC7","DNA-PKcs","RIOK2","FLJ11159","RIOK3","SUDD","SMG1","LIP","KIAA0421","ATX","STK19","D6S60","G11","RP1","TAF1","TAF2A","BA2R","CCG1","CCGS","DYT3","NSCL2","TAFII250","KAT4","DYT3/TAF1","TRIM24","TIF1","hTIF1","Tif1a","RNF82","TIF1A","TRIM28","TIF1B","KAP1","TF1B","RNF96","TRPM6","HOMG","HSH","CHAK2","FLJ22628","TRPM7","CHAK1","LTRPC7","TRP-PLIK","TWF1","PTK9","A6","RIOK1","AD034","FLJ30006","bA288G3.1","RRP10","ADCK4","FLJ12229","COQ8","BRSK1","KIAA1811","BRSK2","C11orf7","STK29","PEN11B","CAMK1","CaMKI","CAMK1D","CKLiK","CAMK1G","VWS1","CLICKIII","dJ272L16.1","CAMK2A","CAMKA","KIAA0968","CaMKIINalpha","CAMK2B","CAMKB","CAM2","CAMK2","CAMK2D","CAMKD","CAMK2G","CAMKG","CAMK4","CaMK-GR","CAMKV","MGC8407","VACAMKL","CASK","TNRC8","LIN2","CAGH39","FGS4","CHEK1","CHK1","CHEK2","RAD53","CDS1","CHK2","HuCds1","PP1425","bA444G7","DAPK1","DAPK","DAPK2","DRP-1","MGC119312","DAPK3","ZIP","ZIPK","DCLK1","DCAMKL1","KIAA0369","DCLK","DCDC3A","DCLK2","DCAMKL2","MGC45428","DCDC3","DCDC3B","DCK2","DCLK3","DCAMKL3","KIAA1765","DCDC3C","HUNK","KALRN","HAPIP","duo","Hs.8004","TRAD","DUET","Kalirin","ARHGEF24","MAPKAPK2","MAPKAPK3","3pK","MAPKAP3","3PK","MAPKAPK5","PRAK","MARK1","MARK","PAR-1C","MARK2","EMK1","PAR-1","Par1b","PAR-1B","MARK3","CTAK1","KP78","PAR-1A","MARK4","MARKL1","Nbla00650","FLJ90097","KIAA1860","PAR-1D","MELK","KIAA0175","MKNK1","MNK1","MKNK2","GPRK7","MNK2","MYLK","MLCK","smMLCK","MYLK1","MLCK1","MYLK2","skMLCK","KMLC","MLCK2","MYLK3","caMLCK","MLCK","MYLK4","SgK085","NUAK1","ARK5","KIAA0537","NuaK1","NUAK2","SNARK","FLJ90349","OBSCN","KIAA1556","UNC89","KIAA1639","ARHGEF30","PASK","PASKIN","KIAA0135","STK37","PHKG1","PHKG","PHKG2","PIM1","PIM","PIM2","PIM3","PNCK","MGC45419","CaMK1b","PRKAA1","AMPKa1","PRKAA2","PRKAA","AMPK","AMPKa2","PRKD1","PRKCM","PKCM","PKD","PKC-mu","PRKD2","PKD2","HSPC187","DKFZP586E0820","PRKD3","PRKCN","EPK2","PSKH1","PSKH2","SIK1","SNF1LK","msk","SIK2","SNF1LK2","KIAA0781","QIK","DKFZp434K1115","LOH11CR1I","SIK3","FLJ12240","L19","KIAA0999","QSK","SNRK","FLJ20224","HSNFRK","KIAA0096","SPEG","APEG1","MGC12676","KIAA1297","SPEGalpha","SPEGbeta","BPEG","STK11","PJS","LKB1","STK17A","DRAK1","STK17B","DRAK2","STK33","STK40","MGC4796","SgK495","TRIO","ARHGEF23","TSSK1B","STK22D","TSSK1","SPOGA4","FKSG81","TSSK2","STK22B","SPOGA2","FLJ38613","TSSK3","STK22C","SPOGA3","TSSK4","C14orf20","STK22E","TSSK6","SSTK","FLJ24002","CT72","TTN","CMD1G","CMPD4","FLJ32040","TMD","CMH9","LGMD2J","MYLK5","NIM1","SgK494","TRIB1","C8FW","GIG2","TRB1","TRIB2","TRB2","GS3955","TRIB3","C20orf97","dJ1103G7.3","TRB3","CSNK1A1","CK1","CK1a","CK1alpha","CKIa","CKIalpha","CSNK1A1L","MGC33182","CSNK1D","HCKID","CKID","CKIdelta","CSNK1E","HCKIE","CKIE","CKIepsilon","CSNK1G1","CK1gamma1","CSNK1G2","CK1g2","CSNK1G3","TTBK1","KIAA1855","TTBK2","SCA11","KIAA0847","VRK1","VRK2","VRK3","CDK1","CDC2","CDC28A","CDK10","PISSLRE","CDK11A","CDK11B","CDC2L1","CDK11-p110","CDK11-p58","CDK11-p46","CDK12","CRKRS","CRK7","CRKR","KIAA0904","CDK13","CDC2L5","CHED","CDC2L","KIAA1791","CDK14","PFTK1","PFTAIRE1","CDK15","ALS2CR7","PFTK2","PFTAIRE2","CDK16","PCTK1","PCTAIRE","PCTAIRE1","PCTGAIRE","FLJ16665","CDK17","PCTK2","PCTAIRE2","CDK18","PCTK3","PCTAIRE3","CDK19","CDK11","CDC2L6","KIAA1028","bA346C16.3","CDK2","CDK20","CCRK","p42","CDK3","CDK4","PSK-J3","CDK5","PSSALRE","CDK6","PLSTIRE","CDK7","CAK1","CDKN7","MO15","STK1","CAK","CDK8","K35","CDK9","CDC2L4","PITALRE","C-2k","TAK","CDKL1","KKIALRE","CDKL2","P56","KKIAMRE","CDKL3","NKIAMRE","CDKL4","CDKL5","STK9","EIEE2","CLK1","CLK2","clk2","CLK3","clk3","CLK4","DYRK1A","DYRK1","DYRK","MNBH","DYRK1B","MIRK","DYRK2","DYRK3","RED","REDK","hYAK3-2","DYRK4","GSK3A","GSK3B","HIPK1","KIAA0630","Myak","MGC26642","Nbak2","MGC33446","MGC33548","HIPK2","HIPK3","PKY","DYRK6","YAK1","FIST3","HIPK4","FLJ32818","ICK","MRK","LCK2","KIAA0936","MGC46090","MAK","dJ417M14.2","MAPK1","PRKM2","PRKM1","ERK","ERK2","p41mapk","MAPK2","MAPK10","PRKM10","JNK3","p493F12","p54bSAPK","MAPK11","PRKM11","p38-2","p38Beta","SAPK2","MAPK12","SAPK3","ERK6","PRKM12","p38gamma","SAPK-3","MAPK13","PRKM13","SAPK4","p38delta","MAPK14","CSPB1","CSBP1","CSBP2","PRKM14","p38","Mxi2","PRKM15","MAPK15","ERK8","ERK7","MAPK3","PRKM3","ERK1","p44mapk","p44erk1","MAPK4","PRKM4","Erk3-related","Erk4","MAPK6","PRKM6","ERK3","p97MAPK","HsT17250","MAPK7","PRKM7","BMK1","ERK5","MAPK8","PRKM8","JNK","JNK1","SAPK1","MAPK9","PRKM9","JNK2","p54a","SAPK","MOK","RAGE","RAGE1","NLK","PRPF4B","Prp4","PR4H","KIAA0536","SRPK1","SFRSK1","SRPK2","SFRSK2","SRPK3","STK23","MSSK1","ABL1","ABL","JTK7","c-ABL","p150","ABL2","ABLL","ARG","BLK","MGC10442","BMX","ETK","PSCTK3","BTK","AGMX1","IMD1","ATK","XLA","PSCTK1","CSK","FER","TYK3","PPP1R74","FES","FPS","FGR","SRC2","c-fgr","p55c-fgr","FRK","PTK5","RAK","GTK","FYN","SYN","SLK","MGC45350","HCK","JTK9","ITK","EMT","PSCTK2","LYK","JAK1","JAK1B","JAK1A","JTK3","JAK2","JTK10","JAK3","L-JAK","JAKL","LJAK","JAK3_HUMAN","JAK-3","LCK","LYN","JTK8","MATK","HYLTK","CTK","HYL","Lsk","CHK","HHYLTK","DKFZp434N1212","MGC1708","MGC2101","PTK2","FAK","FADK","FAK1","PPP1R71","PTK2B","FAK2","CAKB","PYK2","RAFTK","PTK","CADTK","PTK6","BRK","SRC","SRC1","ASV","c-src","SRMS","C20orf148","SRM","dJ697K14.1","SYK","TEC","PSCTK4","TNK1","TNK2","p21cdc42Hs","ACK","ACK1","TXK","PTK4","TKL","PSCTK5","BTKL","RLK","TYK2","JTK1","YES1","Yes","c-yes","HsT441","ZAP70","SRK","ZAP-70","STD","AAK1","KIAA1048","DKFZp686K16132","AURKA","STK15","STK6","BTAK","AurA","STK7","ARK1","PPP1R47","AIK","AURKB","STK12","Aik2","IPL1","AurB","AIM-1","ARK2","STK5","PPP1R48","AURKC","STK13","AurC","ARK3","BMP2K","DKFZp434K0614","BIKe","BUB1","BUB1L","hBUB1","BUB1A","BUB1B","BUBR1","MAD3L","Bub1A","SSK1","C9orf96","MGC43306","CAMKK1","DKFZp761M0423","CAMKKA","MGC34095","CAMKK2","CAMKK","KIAA0787","CAMKKB","MGC15254","CDC7","CDC7L1","Hsk1","huCdc7","HsCdc7","CHUK","TCF16","IKK1","IKK-alpha","IkBKA","NFKBIKA","IKKA","CSNK2A1","CSNK2A2","CSNK2A1","DSTYK","RIPK5","KIAA0472","DustyPK","RIP5","EIF2AK1","HRI","KIAA1369","EIF2AK2","PRKR","PKR","EIF2AK1","EIF2AK3","PEK","PERK","EIF2AK4","GCN2","KIAA1338","ERN1","IRE1","IRE1P","ERN2","IRE1b","GAK","DNAJC26","GSG2","haspin","IKBKAP","DYS","IKAP","TOT1","ELP1","IKI3","IKBKB","IKK2","NFKBIKB","IKK-beta","IKKB","IKBKE","IKKE","IKK-i","KIAA0151","MOS","NEK1","NY-REN-55","KIAA1901","NEK10","FLJ32685","NEK11","FLJ23495","NEK2","NLK1","NEK2A","NEK3","HSPK36","MGC29949","NEK4","STK2","NRK2","pp12301","NEK5","NEK6","SID6-1512","NEK7","NEK8","NPHP9","NEK9","Nek8","NERCC","DKFZp434D0935","MGC16714","NRBP1","NRBP","BCON3","MUDPNP","MADM","NRBP2","DKFZp434P086","PAN3","PBK","TOPK","FLJ14385","Nori-3","SPK","CT84","PDIK1L","CLIK1L","PIK3R4","VPS15","p150","PINK1","PARK6","PKDCC","SgK493","Vlk","PKMYT1","MYT1","PLK1","PLK","PLK2","SNK","PLK3","CNK","FNK","PRK","PLK4","STK18","Sak","PRKAG1","PXK","FLJ20335","RNASEL","RNS4","PRCA1","SBK1","Sbk","SBK2","SGK069","SCYL1","NTKL","HT019","P105","GKLP","NKTL","TAPK","TRAP","TEIF","MGC78454","SCYL2","KIAA1360","SCYL3","PACE-1","PACE1","STK16","PKL12","MPSK","STK31","TDRD8","SgK396","STK35","bA550O8.2","CLIK1","STK36","KIAA1278","FU","TBCK","MGC16169","HSPC302","TBK1","NAK","TEX14","CT113","TLK1","KIAA0137","PKU-BETA","TLK2","PKU-ALPHA","MGC44450","TP53RK","C20orf64","dJ101A2.2","prpk","Nori-2p","BUD32","TTK","MPS1","MPS1L1","CT96","MPH1","UHMK1","KIS","Kist","ULK1","ATG1","ATG1A","ULK2","KIAA0623","Unc51.2","ATG1B","ULK3","DKFZP434C131","FLJ90566","ULK4","FLJ20574","REC01035","FAM7C1","WEE1","WEE2","FLJ16107","WNK1","PRKWNK1","HSN2","HSAN2","WNK2","SDCCAG43","PRKWNK2","NY-CO-43","KIAA1760","WNK3","PRKWNK3","WNK4","PRKWNK4","SBK3","SgK110","POMK","FLJ23356","SgK196","SgK223","PEAK1","KIAA2002","sgk269","PLK5","PLK5P","SgK384ps","GUCY2C","GUC2C","STAR","GUCY2D","CORD6","LCA","GUC2D","GUC1A4","retGC","RETGC-1","ROS-GC1","CYGD","LCA1","GUCY2F","GUC2DL","GC-F","RetGC-2","ROS-GC2","CYGF","NPR1","ANPRA","NPRA","GUCY2A","ANPa","NPR2","ANPRB","NPRB","AMDM","GUCY2B","ANPb","AATK","AATYK","KIAA0641","LMTK1","LMR1","AATYK1","ALK","CD246","AXL","UFO","JTK11","CSF1R","FMS","C-FMS","CSFR","CD115","DDR1","NTRK4","PTK3A","NEP","CAK","EDDR1","RTK6","CD167","DDR2","TYRO10","NTRKR3","TKT","EGFR","ERBB","ERBB1","EPHA1","EPHT","EPHT1","EPH","EPHA10","FLJ16103","FLJ33655","EPHA2","ECK","EPHA3","ETK","ETK1","TYRO4","HEK","HEK4","EPHA4","TYRO1","Hek8","EPHA5","Hek7","TYRO4","CEK7","EHK1","EPHA6","FLJ35246","EPHA7","Hek11","EPHA8","EEK","Hek3","EPHB1","EPHT2","Hek6","EPHB2","DRT","ERK","EPHT3","Hek5","Tyro5","EPHB3","ETK2","Hek2","Tyro6","EPHB4","HTK","Tyro11","EPHB6","HEP","ERBB2","NGL","NEU","HER-2","CD340","HER2","ERBB3","LCCS2","HER3","ERBB4","ALS19","FGFR1","FLT2","KAL2","H2","H3","H4","H5","CEK","FLG","BFGFR","N-SAM","CD331","FGFR2","KGFR","BEK","CFD1","JWS","CEK3","TK14","TK25","ECT1","K-SAM","CD332","FGFR3","ACH","CEK2","JTK4","CD333","FGFR4","JTK2","CD334","FLT1","FLT","VEGFR1","FLT3","STK1","FLK2","CD135","FLT4","VEGFR3","PCL","IGF1R","JTK13","CD221","IGFIR","MGC18216","IGFR","INSR","CD220","INSRR","IRR","KDR","FLK1","VEGFR","VEGFR2","CD309","KIT","PBT","CD117","SCFR","C-Kit","LMTK2","KIAA1079","KPI2","KPI-2","cprk","LMR2","BREK","AATYK2","LMTK3","KIAA1883","LMR3","TYKLM3","LTK","TYK1","MERTK","mer","RP38","MET","HGFR","RCCP2","MST1R","RON","PTK8","CDw136","CD136","MUSK","NTRK1","TRK","TRKA","MTC","NTRK2","TRKB","NTRK3","TRKC","PDGFRA","CD140a","PDGFR2","PDGFRB","PDGFR","JTK12","CD140b","PDGFR1","PTK7","CCK4","RET","HSCR1","MEN2A","MTC1","MEN2B","PTC","CDHF12","RET51","CDHR16","ROR1","NTRKR1","ROR2","NTRKR2","BDB","BDB1","ROS1","MCF3","ROS","c-ros-1","RYK","JTK5A","D3S3195","RYK1","JTK5","STYK1","SuRTK106","DKFZp761P1010","NOK","TEK","VMCM","TIE2","TIE-2","VMCM1","CD202b","TIE1","TIE","JTK14","TYRO3","RSE","Dtk","Brt","Tif","Sky","MAP2K1","PRKMK1","MEK1","MAPKK1","MAP2K2","PRKMK2","MEK2","MAP2K3","PRKMK3","MEK3","MKK3","MAPKK3","MAP2K4","SERK1","MEK4","JNKK1","PRKMK4","MKK4","MAP2K5","PRKMK5","MEK5","MAPKK5","HsT17454","MAP2K6","PRKMK6","MEK6","MKK6","SAPKK3","MAPKK6","MAP2K7","PRKMK7","MKK7","Jnkk2","MAP3K1","MEKK1","MEKK","MAPKKK1","MAP3K14","NIK","HSNIK","FTDCR1B","HS","MAP3K15","bA723P2.3","FLJ16518","MAP3K2","MEKK2","MEKK2B","MAP3K3","MEKK3","MAPKKK3","MAP3K4","MEKK4","MTK1","MAPKKK4","KIAA0213","MAP3K5","MEKK5","MAPKKK5","ASK1","MAP3K6","MAPKKK6","ASK2","MEKK6","MAP3K8","COT","ESTF","Tpl-2","EST","c-COT","MEKK8","MAP4K1","HPK1","MAP4K2","RAB8IP","GCK","BL44","MAP4K3","RAB8IPL1","GLK","MAPKKKK3","MAP4K4","HGK","NIK","FLH21957","MAP4K5","KHS1","GCKR","KHS","MINK1","B55","MINK","ZC3","MAP4K6","YSK2","MYO3A","DFNB30","MYO3B","NRK","DKFZp686A17109","OXSR1","OSR1","KIAA1101","PAK1","PAK2","PAK65","PAKgamma","PAK3","MRX30","MRX47","hPAK3","bPAK","PAK4","PAK6","PAK5","PAK7","KIAA1264","PAK5","SLK","STK2","se20-9","KIAA0204","STK10","LOK","PRO2729","STK24","MST-3","MST3","MST3B","STK3","STE20","STK25","SOK1","YSK1","STK3","MST2","KRS1","STK39","DCHT","SPAK","STK4","MST1","KRS2","YSK3","STRADA","NY-BR-96","LYK5","Stlk","STRAD","STRADB","ALS2CR2","CALS-21","PAPK","ILPIPA","ILPIP","TAOK1","KIAA1361","MARKK","PSK2","MAP3K16","FLJ14314","TAO1","TAOK2","TAO1","KIAA0881","PSK","PSK1","TAO2","MAP3K17","TAOK3","JIK","DPK","MAP3K18","TNIK","KIAA0551","MAP3K19","YSK4","FLJ23074","MST4","ACVR1","ACVRLK2","SKR1","ALK2","ACVR1A","ACVR1B","ACVRLK4","ALK4","SKR2","ActRIB","ACVR1C","ALK7","ACVRLK7","ACVR2A","ACVR2","ACTRII","ACVR2B","ActR-IIB","ACVRL1","ACVRLK1","ORW2","HHT2","ALK1","HHT","AMHR2","MISR2","MISRII","ANKK1","X-kinase","ARAF","ARAF1","BMPR1A","ACVRLK3","ALK3","CD292","BMPR1B","ALK6","CDw293","BMPR2","PPH1","BRK-3","T-ALK","BMPR3","BMPR-II","BRAF","BRAF1","ILK","IRAK1","IRAK","pelle","IRAK2","IRAK3","IRAK-M","IRAK4","NY-REN-64","KSR1","KSR","RSU2","KSR2","FLJ25965","LIMK1","LIMK","LIMK2","LRRK1","FLJ23119","KIAA1790","Roco1","RIPK6","LRRK2","PARK8","ROCO2","DKFZp434H2111","FLJ45829","RIPK7","MAP3K10","MLK2","MST","MEKK10","MAP3K11","MLK3","PTK1","SPRK","MEKK11","MAP3K12","ZPK","MUK","DLK","ZPKP1","MEKK12","MAP3K13","LZK","MEKK13","MAP3K7","TAK1","MEKK7","MAP3K9","MLK1","PRKE1","MEKK9","MLKL","FLJ34389","RAF1","Raf-1","c-Raf","CRAF","RIPK1","RIP","RIPK2","RICK","RIP2","CARDIAK","CARD3","RIPK3","RIP3","RIPK4","ANKRD3","DIK","ANKK2","RIP4","PKK","TESK1","TESK2","TGFBR1","ALK-5","ACVRLK4","TGFBR2","MFS2","TNNI3K","CARK","MLK4","MLTK"]
	# Open Output File
	ffus=open(ffusion,"w")
	# Read Input File
	with open(fin,"r") as f:
		while True:
			var_test=False
			# Read 12 lines
			next_lines=list(islice(f,nlines))
			if not next_lines:
				break
			# For each kinases
			for sk in search_kinase:
				# Search in Title and Abstract
				btitle=exact_Match(next_lines[1].strip(),sk)
				babstract=exact_Match(next_lines[2].strip(),sk)
				if(btitle or babstract):
					var_test=True
					break
			if(var_test):
				for start in range(0,len(next_lines),1):
					# Write Output File
					ffus.write(next_lines[start])
	# Close Output File
	ffus.close()

# Main
main()
